//go:build !ignore_autogenerated
// +build !ignore_autogenerated

/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by controller-gen. DO NOT EDIT.

package v1beta1

import (
	"github.com/metal3-io/ip-address-manager/api/v1alpha1"
	"k8s.io/api/core/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	"k8s.io/apimachinery/pkg/runtime"
	apiv1beta1 "sigs.k8s.io/cluster-api/api/v1beta1"
	"sigs.k8s.io/cluster-api/errors"
)

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *APIEndpoint) DeepCopyInto(out *APIEndpoint) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new APIEndpoint.
func (in *APIEndpoint) DeepCopy() *APIEndpoint {
	if in == nil {
		return nil
	}
	out := new(APIEndpoint)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *FromPool) DeepCopyInto(out *FromPool) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new FromPool.
func (in *FromPool) DeepCopy() *FromPool {
	if in == nil {
		return nil
	}
	out := new(FromPool)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *HostSelector) DeepCopyInto(out *HostSelector) {
	*out = *in
	if in.MatchLabels != nil {
		in, out := &in.MatchLabels, &out.MatchLabels
		*out = make(map[string]string, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
	if in.MatchExpressions != nil {
		in, out := &in.MatchExpressions, &out.MatchExpressions
		*out = make([]HostSelectorRequirement, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new HostSelector.
func (in *HostSelector) DeepCopy() *HostSelector {
	if in == nil {
		return nil
	}
	out := new(HostSelector)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *HostSelectorRequirement) DeepCopyInto(out *HostSelectorRequirement) {
	*out = *in
	if in.Values != nil {
		in, out := &in.Values, &out.Values
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new HostSelectorRequirement.
func (in *HostSelectorRequirement) DeepCopy() *HostSelectorRequirement {
	if in == nil {
		return nil
	}
	out := new(HostSelectorRequirement)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Image) DeepCopyInto(out *Image) {
	*out = *in
	if in.ChecksumType != nil {
		in, out := &in.ChecksumType, &out.ChecksumType
		*out = new(string)
		**out = **in
	}
	if in.DiskFormat != nil {
		in, out := &in.DiskFormat, &out.DiskFormat
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Image.
func (in *Image) DeepCopy() *Image {
	if in == nil {
		return nil
	}
	out := new(Image)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MetaData) DeepCopyInto(out *MetaData) {
	*out = *in
	if in.Strings != nil {
		in, out := &in.Strings, &out.Strings
		*out = make([]MetaDataString, len(*in))
		copy(*out, *in)
	}
	if in.ObjectNames != nil {
		in, out := &in.ObjectNames, &out.ObjectNames
		*out = make([]MetaDataObjectName, len(*in))
		copy(*out, *in)
	}
	if in.Indexes != nil {
		in, out := &in.Indexes, &out.Indexes
		*out = make([]MetaDataIndex, len(*in))
		copy(*out, *in)
	}
	if in.Namespaces != nil {
		in, out := &in.Namespaces, &out.Namespaces
		*out = make([]MetaDataNamespace, len(*in))
		copy(*out, *in)
	}
	if in.IPAddressesFromPool != nil {
		in, out := &in.IPAddressesFromPool, &out.IPAddressesFromPool
		*out = make([]FromPool, len(*in))
		copy(*out, *in)
	}
	if in.PrefixesFromPool != nil {
		in, out := &in.PrefixesFromPool, &out.PrefixesFromPool
		*out = make([]FromPool, len(*in))
		copy(*out, *in)
	}
	if in.GatewaysFromPool != nil {
		in, out := &in.GatewaysFromPool, &out.GatewaysFromPool
		*out = make([]FromPool, len(*in))
		copy(*out, *in)
	}
	if in.DNSServersFromPool != nil {
		in, out := &in.DNSServersFromPool, &out.DNSServersFromPool
		*out = make([]FromPool, len(*in))
		copy(*out, *in)
	}
	if in.FromHostInterfaces != nil {
		in, out := &in.FromHostInterfaces, &out.FromHostInterfaces
		*out = make([]MetaDataHostInterface, len(*in))
		copy(*out, *in)
	}
	if in.FromLabels != nil {
		in, out := &in.FromLabels, &out.FromLabels
		*out = make([]MetaDataFromLabel, len(*in))
		copy(*out, *in)
	}
	if in.FromAnnotations != nil {
		in, out := &in.FromAnnotations, &out.FromAnnotations
		*out = make([]MetaDataFromAnnotation, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MetaData.
func (in *MetaData) DeepCopy() *MetaData {
	if in == nil {
		return nil
	}
	out := new(MetaData)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MetaDataFromAnnotation) DeepCopyInto(out *MetaDataFromAnnotation) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MetaDataFromAnnotation.
func (in *MetaDataFromAnnotation) DeepCopy() *MetaDataFromAnnotation {
	if in == nil {
		return nil
	}
	out := new(MetaDataFromAnnotation)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MetaDataFromLabel) DeepCopyInto(out *MetaDataFromLabel) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MetaDataFromLabel.
func (in *MetaDataFromLabel) DeepCopy() *MetaDataFromLabel {
	if in == nil {
		return nil
	}
	out := new(MetaDataFromLabel)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MetaDataHostInterface) DeepCopyInto(out *MetaDataHostInterface) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MetaDataHostInterface.
func (in *MetaDataHostInterface) DeepCopy() *MetaDataHostInterface {
	if in == nil {
		return nil
	}
	out := new(MetaDataHostInterface)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MetaDataIPAddress) DeepCopyInto(out *MetaDataIPAddress) {
	*out = *in
	if in.Start != nil {
		in, out := &in.Start, &out.Start
		*out = new(v1alpha1.IPAddressStr)
		**out = **in
	}
	if in.End != nil {
		in, out := &in.End, &out.End
		*out = new(v1alpha1.IPAddressStr)
		**out = **in
	}
	if in.Subnet != nil {
		in, out := &in.Subnet, &out.Subnet
		*out = new(v1alpha1.IPSubnetStr)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MetaDataIPAddress.
func (in *MetaDataIPAddress) DeepCopy() *MetaDataIPAddress {
	if in == nil {
		return nil
	}
	out := new(MetaDataIPAddress)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MetaDataIndex) DeepCopyInto(out *MetaDataIndex) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MetaDataIndex.
func (in *MetaDataIndex) DeepCopy() *MetaDataIndex {
	if in == nil {
		return nil
	}
	out := new(MetaDataIndex)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MetaDataNamespace) DeepCopyInto(out *MetaDataNamespace) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MetaDataNamespace.
func (in *MetaDataNamespace) DeepCopy() *MetaDataNamespace {
	if in == nil {
		return nil
	}
	out := new(MetaDataNamespace)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MetaDataObjectName) DeepCopyInto(out *MetaDataObjectName) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MetaDataObjectName.
func (in *MetaDataObjectName) DeepCopy() *MetaDataObjectName {
	if in == nil {
		return nil
	}
	out := new(MetaDataObjectName)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *MetaDataString) DeepCopyInto(out *MetaDataString) {
	*out = *in
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new MetaDataString.
func (in *MetaDataString) DeepCopy() *MetaDataString {
	if in == nil {
		return nil
	}
	out := new(MetaDataString)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3Cluster) DeepCopyInto(out *Metal3Cluster) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	out.Spec = in.Spec
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3Cluster.
func (in *Metal3Cluster) DeepCopy() *Metal3Cluster {
	if in == nil {
		return nil
	}
	out := new(Metal3Cluster)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3Cluster) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3ClusterList) DeepCopyInto(out *Metal3ClusterList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Metal3Cluster, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3ClusterList.
func (in *Metal3ClusterList) DeepCopy() *Metal3ClusterList {
	if in == nil {
		return nil
	}
	out := new(Metal3ClusterList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3ClusterList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3ClusterSpec) DeepCopyInto(out *Metal3ClusterSpec) {
	*out = *in
	out.ControlPlaneEndpoint = in.ControlPlaneEndpoint
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3ClusterSpec.
func (in *Metal3ClusterSpec) DeepCopy() *Metal3ClusterSpec {
	if in == nil {
		return nil
	}
	out := new(Metal3ClusterSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3ClusterStatus) DeepCopyInto(out *Metal3ClusterStatus) {
	*out = *in
	if in.LastUpdated != nil {
		in, out := &in.LastUpdated, &out.LastUpdated
		*out = (*in).DeepCopy()
	}
	if in.FailureReason != nil {
		in, out := &in.FailureReason, &out.FailureReason
		*out = new(errors.ClusterStatusError)
		**out = **in
	}
	if in.FailureMessage != nil {
		in, out := &in.FailureMessage, &out.FailureMessage
		*out = new(string)
		**out = **in
	}
	if in.Conditions != nil {
		in, out := &in.Conditions, &out.Conditions
		*out = make(apiv1beta1.Conditions, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3ClusterStatus.
func (in *Metal3ClusterStatus) DeepCopy() *Metal3ClusterStatus {
	if in == nil {
		return nil
	}
	out := new(Metal3ClusterStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3Data) DeepCopyInto(out *Metal3Data) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3Data.
func (in *Metal3Data) DeepCopy() *Metal3Data {
	if in == nil {
		return nil
	}
	out := new(Metal3Data)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3Data) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3DataClaim) DeepCopyInto(out *Metal3DataClaim) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	out.Spec = in.Spec
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3DataClaim.
func (in *Metal3DataClaim) DeepCopy() *Metal3DataClaim {
	if in == nil {
		return nil
	}
	out := new(Metal3DataClaim)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3DataClaim) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3DataClaimList) DeepCopyInto(out *Metal3DataClaimList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Metal3DataClaim, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3DataClaimList.
func (in *Metal3DataClaimList) DeepCopy() *Metal3DataClaimList {
	if in == nil {
		return nil
	}
	out := new(Metal3DataClaimList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3DataClaimList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3DataClaimSpec) DeepCopyInto(out *Metal3DataClaimSpec) {
	*out = *in
	out.Template = in.Template
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3DataClaimSpec.
func (in *Metal3DataClaimSpec) DeepCopy() *Metal3DataClaimSpec {
	if in == nil {
		return nil
	}
	out := new(Metal3DataClaimSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3DataClaimStatus) DeepCopyInto(out *Metal3DataClaimStatus) {
	*out = *in
	if in.RenderedData != nil {
		in, out := &in.RenderedData, &out.RenderedData
		*out = new(v1.ObjectReference)
		**out = **in
	}
	if in.ErrorMessage != nil {
		in, out := &in.ErrorMessage, &out.ErrorMessage
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3DataClaimStatus.
func (in *Metal3DataClaimStatus) DeepCopy() *Metal3DataClaimStatus {
	if in == nil {
		return nil
	}
	out := new(Metal3DataClaimStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3DataList) DeepCopyInto(out *Metal3DataList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Metal3Data, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3DataList.
func (in *Metal3DataList) DeepCopy() *Metal3DataList {
	if in == nil {
		return nil
	}
	out := new(Metal3DataList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3DataList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3DataSpec) DeepCopyInto(out *Metal3DataSpec) {
	*out = *in
	if in.MetaData != nil {
		in, out := &in.MetaData, &out.MetaData
		*out = new(v1.SecretReference)
		**out = **in
	}
	if in.NetworkData != nil {
		in, out := &in.NetworkData, &out.NetworkData
		*out = new(v1.SecretReference)
		**out = **in
	}
	out.Claim = in.Claim
	out.Template = in.Template
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3DataSpec.
func (in *Metal3DataSpec) DeepCopy() *Metal3DataSpec {
	if in == nil {
		return nil
	}
	out := new(Metal3DataSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3DataStatus) DeepCopyInto(out *Metal3DataStatus) {
	*out = *in
	if in.ErrorMessage != nil {
		in, out := &in.ErrorMessage, &out.ErrorMessage
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3DataStatus.
func (in *Metal3DataStatus) DeepCopy() *Metal3DataStatus {
	if in == nil {
		return nil
	}
	out := new(Metal3DataStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3DataTemplate) DeepCopyInto(out *Metal3DataTemplate) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3DataTemplate.
func (in *Metal3DataTemplate) DeepCopy() *Metal3DataTemplate {
	if in == nil {
		return nil
	}
	out := new(Metal3DataTemplate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3DataTemplate) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3DataTemplateList) DeepCopyInto(out *Metal3DataTemplateList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Metal3DataTemplate, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3DataTemplateList.
func (in *Metal3DataTemplateList) DeepCopy() *Metal3DataTemplateList {
	if in == nil {
		return nil
	}
	out := new(Metal3DataTemplateList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3DataTemplateList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3DataTemplateSpec) DeepCopyInto(out *Metal3DataTemplateSpec) {
	*out = *in
	if in.MetaData != nil {
		in, out := &in.MetaData, &out.MetaData
		*out = new(MetaData)
		(*in).DeepCopyInto(*out)
	}
	if in.NetworkData != nil {
		in, out := &in.NetworkData, &out.NetworkData
		*out = new(NetworkData)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3DataTemplateSpec.
func (in *Metal3DataTemplateSpec) DeepCopy() *Metal3DataTemplateSpec {
	if in == nil {
		return nil
	}
	out := new(Metal3DataTemplateSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3DataTemplateStatus) DeepCopyInto(out *Metal3DataTemplateStatus) {
	*out = *in
	if in.LastUpdated != nil {
		in, out := &in.LastUpdated, &out.LastUpdated
		*out = (*in).DeepCopy()
	}
	if in.Indexes != nil {
		in, out := &in.Indexes, &out.Indexes
		*out = make(map[string]int, len(*in))
		for key, val := range *in {
			(*out)[key] = val
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3DataTemplateStatus.
func (in *Metal3DataTemplateStatus) DeepCopy() *Metal3DataTemplateStatus {
	if in == nil {
		return nil
	}
	out := new(Metal3DataTemplateStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3Machine) DeepCopyInto(out *Metal3Machine) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3Machine.
func (in *Metal3Machine) DeepCopy() *Metal3Machine {
	if in == nil {
		return nil
	}
	out := new(Metal3Machine)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3Machine) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3MachineList) DeepCopyInto(out *Metal3MachineList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Metal3Machine, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3MachineList.
func (in *Metal3MachineList) DeepCopy() *Metal3MachineList {
	if in == nil {
		return nil
	}
	out := new(Metal3MachineList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3MachineList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3MachineSpec) DeepCopyInto(out *Metal3MachineSpec) {
	*out = *in
	if in.ProviderID != nil {
		in, out := &in.ProviderID, &out.ProviderID
		*out = new(string)
		**out = **in
	}
	in.Image.DeepCopyInto(&out.Image)
	if in.UserData != nil {
		in, out := &in.UserData, &out.UserData
		*out = new(v1.SecretReference)
		**out = **in
	}
	in.HostSelector.DeepCopyInto(&out.HostSelector)
	if in.DataTemplate != nil {
		in, out := &in.DataTemplate, &out.DataTemplate
		*out = new(v1.ObjectReference)
		**out = **in
	}
	if in.MetaData != nil {
		in, out := &in.MetaData, &out.MetaData
		*out = new(v1.SecretReference)
		**out = **in
	}
	if in.NetworkData != nil {
		in, out := &in.NetworkData, &out.NetworkData
		*out = new(v1.SecretReference)
		**out = **in
	}
	if in.AutomatedCleaningMode != nil {
		in, out := &in.AutomatedCleaningMode, &out.AutomatedCleaningMode
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3MachineSpec.
func (in *Metal3MachineSpec) DeepCopy() *Metal3MachineSpec {
	if in == nil {
		return nil
	}
	out := new(Metal3MachineSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3MachineStatus) DeepCopyInto(out *Metal3MachineStatus) {
	*out = *in
	if in.LastUpdated != nil {
		in, out := &in.LastUpdated, &out.LastUpdated
		*out = (*in).DeepCopy()
	}
	if in.FailureReason != nil {
		in, out := &in.FailureReason, &out.FailureReason
		*out = new(errors.MachineStatusError)
		**out = **in
	}
	if in.FailureMessage != nil {
		in, out := &in.FailureMessage, &out.FailureMessage
		*out = new(string)
		**out = **in
	}
	if in.Addresses != nil {
		in, out := &in.Addresses, &out.Addresses
		*out = make(apiv1beta1.MachineAddresses, len(*in))
		copy(*out, *in)
	}
	if in.UserData != nil {
		in, out := &in.UserData, &out.UserData
		*out = new(v1.SecretReference)
		**out = **in
	}
	if in.RenderedData != nil {
		in, out := &in.RenderedData, &out.RenderedData
		*out = new(v1.ObjectReference)
		**out = **in
	}
	if in.MetaData != nil {
		in, out := &in.MetaData, &out.MetaData
		*out = new(v1.SecretReference)
		**out = **in
	}
	if in.NetworkData != nil {
		in, out := &in.NetworkData, &out.NetworkData
		*out = new(v1.SecretReference)
		**out = **in
	}
	if in.Conditions != nil {
		in, out := &in.Conditions, &out.Conditions
		*out = make(apiv1beta1.Conditions, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3MachineStatus.
func (in *Metal3MachineStatus) DeepCopy() *Metal3MachineStatus {
	if in == nil {
		return nil
	}
	out := new(Metal3MachineStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3MachineTemplate) DeepCopyInto(out *Metal3MachineTemplate) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3MachineTemplate.
func (in *Metal3MachineTemplate) DeepCopy() *Metal3MachineTemplate {
	if in == nil {
		return nil
	}
	out := new(Metal3MachineTemplate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3MachineTemplate) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3MachineTemplateList) DeepCopyInto(out *Metal3MachineTemplateList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Metal3MachineTemplate, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3MachineTemplateList.
func (in *Metal3MachineTemplateList) DeepCopy() *Metal3MachineTemplateList {
	if in == nil {
		return nil
	}
	out := new(Metal3MachineTemplateList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3MachineTemplateList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3MachineTemplateResource) DeepCopyInto(out *Metal3MachineTemplateResource) {
	*out = *in
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3MachineTemplateResource.
func (in *Metal3MachineTemplateResource) DeepCopy() *Metal3MachineTemplateResource {
	if in == nil {
		return nil
	}
	out := new(Metal3MachineTemplateResource)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3MachineTemplateSpec) DeepCopyInto(out *Metal3MachineTemplateSpec) {
	*out = *in
	in.Template.DeepCopyInto(&out.Template)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3MachineTemplateSpec.
func (in *Metal3MachineTemplateSpec) DeepCopy() *Metal3MachineTemplateSpec {
	if in == nil {
		return nil
	}
	out := new(Metal3MachineTemplateSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3Remediation) DeepCopyInto(out *Metal3Remediation) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3Remediation.
func (in *Metal3Remediation) DeepCopy() *Metal3Remediation {
	if in == nil {
		return nil
	}
	out := new(Metal3Remediation)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3Remediation) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3RemediationList) DeepCopyInto(out *Metal3RemediationList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Metal3Remediation, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3RemediationList.
func (in *Metal3RemediationList) DeepCopy() *Metal3RemediationList {
	if in == nil {
		return nil
	}
	out := new(Metal3RemediationList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3RemediationList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3RemediationSpec) DeepCopyInto(out *Metal3RemediationSpec) {
	*out = *in
	if in.Strategy != nil {
		in, out := &in.Strategy, &out.Strategy
		*out = new(RemediationStrategy)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3RemediationSpec.
func (in *Metal3RemediationSpec) DeepCopy() *Metal3RemediationSpec {
	if in == nil {
		return nil
	}
	out := new(Metal3RemediationSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3RemediationStatus) DeepCopyInto(out *Metal3RemediationStatus) {
	*out = *in
	if in.LastRemediated != nil {
		in, out := &in.LastRemediated, &out.LastRemediated
		*out = (*in).DeepCopy()
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3RemediationStatus.
func (in *Metal3RemediationStatus) DeepCopy() *Metal3RemediationStatus {
	if in == nil {
		return nil
	}
	out := new(Metal3RemediationStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3RemediationTemplate) DeepCopyInto(out *Metal3RemediationTemplate) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ObjectMeta.DeepCopyInto(&out.ObjectMeta)
	in.Spec.DeepCopyInto(&out.Spec)
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3RemediationTemplate.
func (in *Metal3RemediationTemplate) DeepCopy() *Metal3RemediationTemplate {
	if in == nil {
		return nil
	}
	out := new(Metal3RemediationTemplate)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3RemediationTemplate) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3RemediationTemplateList) DeepCopyInto(out *Metal3RemediationTemplateList) {
	*out = *in
	out.TypeMeta = in.TypeMeta
	in.ListMeta.DeepCopyInto(&out.ListMeta)
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]Metal3RemediationTemplate, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3RemediationTemplateList.
func (in *Metal3RemediationTemplateList) DeepCopy() *Metal3RemediationTemplateList {
	if in == nil {
		return nil
	}
	out := new(Metal3RemediationTemplateList)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyObject is an autogenerated deepcopy function, copying the receiver, creating a new runtime.Object.
func (in *Metal3RemediationTemplateList) DeepCopyObject() runtime.Object {
	if c := in.DeepCopy(); c != nil {
		return c
	}
	return nil
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3RemediationTemplateResource) DeepCopyInto(out *Metal3RemediationTemplateResource) {
	*out = *in
	in.Spec.DeepCopyInto(&out.Spec)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3RemediationTemplateResource.
func (in *Metal3RemediationTemplateResource) DeepCopy() *Metal3RemediationTemplateResource {
	if in == nil {
		return nil
	}
	out := new(Metal3RemediationTemplateResource)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3RemediationTemplateSpec) DeepCopyInto(out *Metal3RemediationTemplateSpec) {
	*out = *in
	in.Template.DeepCopyInto(&out.Template)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3RemediationTemplateSpec.
func (in *Metal3RemediationTemplateSpec) DeepCopy() *Metal3RemediationTemplateSpec {
	if in == nil {
		return nil
	}
	out := new(Metal3RemediationTemplateSpec)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *Metal3RemediationTemplateStatus) DeepCopyInto(out *Metal3RemediationTemplateStatus) {
	*out = *in
	in.Status.DeepCopyInto(&out.Status)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new Metal3RemediationTemplateStatus.
func (in *Metal3RemediationTemplateStatus) DeepCopy() *Metal3RemediationTemplateStatus {
	if in == nil {
		return nil
	}
	out := new(Metal3RemediationTemplateStatus)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkData) DeepCopyInto(out *NetworkData) {
	*out = *in
	in.Links.DeepCopyInto(&out.Links)
	in.Networks.DeepCopyInto(&out.Networks)
	in.Services.DeepCopyInto(&out.Services)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkData.
func (in *NetworkData) DeepCopy() *NetworkData {
	if in == nil {
		return nil
	}
	out := new(NetworkData)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataIPv4) DeepCopyInto(out *NetworkDataIPv4) {
	*out = *in
	if in.Routes != nil {
		in, out := &in.Routes, &out.Routes
		*out = make([]NetworkDataRoutev4, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataIPv4.
func (in *NetworkDataIPv4) DeepCopy() *NetworkDataIPv4 {
	if in == nil {
		return nil
	}
	out := new(NetworkDataIPv4)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataIPv4DHCP) DeepCopyInto(out *NetworkDataIPv4DHCP) {
	*out = *in
	if in.Routes != nil {
		in, out := &in.Routes, &out.Routes
		*out = make([]NetworkDataRoutev4, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataIPv4DHCP.
func (in *NetworkDataIPv4DHCP) DeepCopy() *NetworkDataIPv4DHCP {
	if in == nil {
		return nil
	}
	out := new(NetworkDataIPv4DHCP)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataIPv6) DeepCopyInto(out *NetworkDataIPv6) {
	*out = *in
	if in.Routes != nil {
		in, out := &in.Routes, &out.Routes
		*out = make([]NetworkDataRoutev6, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataIPv6.
func (in *NetworkDataIPv6) DeepCopy() *NetworkDataIPv6 {
	if in == nil {
		return nil
	}
	out := new(NetworkDataIPv6)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataIPv6DHCP) DeepCopyInto(out *NetworkDataIPv6DHCP) {
	*out = *in
	if in.Routes != nil {
		in, out := &in.Routes, &out.Routes
		*out = make([]NetworkDataRoutev6, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataIPv6DHCP.
func (in *NetworkDataIPv6DHCP) DeepCopy() *NetworkDataIPv6DHCP {
	if in == nil {
		return nil
	}
	out := new(NetworkDataIPv6DHCP)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataLink) DeepCopyInto(out *NetworkDataLink) {
	*out = *in
	if in.Ethernets != nil {
		in, out := &in.Ethernets, &out.Ethernets
		*out = make([]NetworkDataLinkEthernet, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.Bonds != nil {
		in, out := &in.Bonds, &out.Bonds
		*out = make([]NetworkDataLinkBond, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.Vlans != nil {
		in, out := &in.Vlans, &out.Vlans
		*out = make([]NetworkDataLinkVlan, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataLink.
func (in *NetworkDataLink) DeepCopy() *NetworkDataLink {
	if in == nil {
		return nil
	}
	out := new(NetworkDataLink)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataLinkBond) DeepCopyInto(out *NetworkDataLinkBond) {
	*out = *in
	if in.MACAddress != nil {
		in, out := &in.MACAddress, &out.MACAddress
		*out = new(NetworkLinkEthernetMac)
		(*in).DeepCopyInto(*out)
	}
	if in.BondLinks != nil {
		in, out := &in.BondLinks, &out.BondLinks
		*out = make([]string, len(*in))
		copy(*out, *in)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataLinkBond.
func (in *NetworkDataLinkBond) DeepCopy() *NetworkDataLinkBond {
	if in == nil {
		return nil
	}
	out := new(NetworkDataLinkBond)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataLinkEthernet) DeepCopyInto(out *NetworkDataLinkEthernet) {
	*out = *in
	if in.MACAddress != nil {
		in, out := &in.MACAddress, &out.MACAddress
		*out = new(NetworkLinkEthernetMac)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataLinkEthernet.
func (in *NetworkDataLinkEthernet) DeepCopy() *NetworkDataLinkEthernet {
	if in == nil {
		return nil
	}
	out := new(NetworkDataLinkEthernet)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataLinkVlan) DeepCopyInto(out *NetworkDataLinkVlan) {
	*out = *in
	if in.MACAddress != nil {
		in, out := &in.MACAddress, &out.MACAddress
		*out = new(NetworkLinkEthernetMac)
		(*in).DeepCopyInto(*out)
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataLinkVlan.
func (in *NetworkDataLinkVlan) DeepCopy() *NetworkDataLinkVlan {
	if in == nil {
		return nil
	}
	out := new(NetworkDataLinkVlan)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataNetwork) DeepCopyInto(out *NetworkDataNetwork) {
	*out = *in
	if in.IPv4 != nil {
		in, out := &in.IPv4, &out.IPv4
		*out = make([]NetworkDataIPv4, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.IPv6 != nil {
		in, out := &in.IPv6, &out.IPv6
		*out = make([]NetworkDataIPv6, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.IPv4DHCP != nil {
		in, out := &in.IPv4DHCP, &out.IPv4DHCP
		*out = make([]NetworkDataIPv4DHCP, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.IPv6DHCP != nil {
		in, out := &in.IPv6DHCP, &out.IPv6DHCP
		*out = make([]NetworkDataIPv6DHCP, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
	if in.IPv6SLAAC != nil {
		in, out := &in.IPv6SLAAC, &out.IPv6SLAAC
		*out = make([]NetworkDataIPv6DHCP, len(*in))
		for i := range *in {
			(*in)[i].DeepCopyInto(&(*out)[i])
		}
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataNetwork.
func (in *NetworkDataNetwork) DeepCopy() *NetworkDataNetwork {
	if in == nil {
		return nil
	}
	out := new(NetworkDataNetwork)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataRoutev4) DeepCopyInto(out *NetworkDataRoutev4) {
	*out = *in
	in.Gateway.DeepCopyInto(&out.Gateway)
	in.Services.DeepCopyInto(&out.Services)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataRoutev4.
func (in *NetworkDataRoutev4) DeepCopy() *NetworkDataRoutev4 {
	if in == nil {
		return nil
	}
	out := new(NetworkDataRoutev4)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataRoutev6) DeepCopyInto(out *NetworkDataRoutev6) {
	*out = *in
	in.Gateway.DeepCopyInto(&out.Gateway)
	in.Services.DeepCopyInto(&out.Services)
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataRoutev6.
func (in *NetworkDataRoutev6) DeepCopy() *NetworkDataRoutev6 {
	if in == nil {
		return nil
	}
	out := new(NetworkDataRoutev6)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataService) DeepCopyInto(out *NetworkDataService) {
	*out = *in
	if in.DNS != nil {
		in, out := &in.DNS, &out.DNS
		*out = make([]v1alpha1.IPAddressStr, len(*in))
		copy(*out, *in)
	}
	if in.DNSFromIPPool != nil {
		in, out := &in.DNSFromIPPool, &out.DNSFromIPPool
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataService.
func (in *NetworkDataService) DeepCopy() *NetworkDataService {
	if in == nil {
		return nil
	}
	out := new(NetworkDataService)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataServicev4) DeepCopyInto(out *NetworkDataServicev4) {
	*out = *in
	if in.DNS != nil {
		in, out := &in.DNS, &out.DNS
		*out = make([]v1alpha1.IPAddressv4Str, len(*in))
		copy(*out, *in)
	}
	if in.DNSFromIPPool != nil {
		in, out := &in.DNSFromIPPool, &out.DNSFromIPPool
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataServicev4.
func (in *NetworkDataServicev4) DeepCopy() *NetworkDataServicev4 {
	if in == nil {
		return nil
	}
	out := new(NetworkDataServicev4)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkDataServicev6) DeepCopyInto(out *NetworkDataServicev6) {
	*out = *in
	if in.DNS != nil {
		in, out := &in.DNS, &out.DNS
		*out = make([]v1alpha1.IPAddressv6Str, len(*in))
		copy(*out, *in)
	}
	if in.DNSFromIPPool != nil {
		in, out := &in.DNSFromIPPool, &out.DNSFromIPPool
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkDataServicev6.
func (in *NetworkDataServicev6) DeepCopy() *NetworkDataServicev6 {
	if in == nil {
		return nil
	}
	out := new(NetworkDataServicev6)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkGatewayv4) DeepCopyInto(out *NetworkGatewayv4) {
	*out = *in
	if in.String != nil {
		in, out := &in.String, &out.String
		*out = new(v1alpha1.IPAddressv4Str)
		**out = **in
	}
	if in.FromIPPool != nil {
		in, out := &in.FromIPPool, &out.FromIPPool
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkGatewayv4.
func (in *NetworkGatewayv4) DeepCopy() *NetworkGatewayv4 {
	if in == nil {
		return nil
	}
	out := new(NetworkGatewayv4)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkGatewayv6) DeepCopyInto(out *NetworkGatewayv6) {
	*out = *in
	if in.String != nil {
		in, out := &in.String, &out.String
		*out = new(v1alpha1.IPAddressv6Str)
		**out = **in
	}
	if in.FromIPPool != nil {
		in, out := &in.FromIPPool, &out.FromIPPool
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkGatewayv6.
func (in *NetworkGatewayv6) DeepCopy() *NetworkGatewayv6 {
	if in == nil {
		return nil
	}
	out := new(NetworkGatewayv6)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *NetworkLinkEthernetMac) DeepCopyInto(out *NetworkLinkEthernetMac) {
	*out = *in
	if in.String != nil {
		in, out := &in.String, &out.String
		*out = new(string)
		**out = **in
	}
	if in.FromHostInterface != nil {
		in, out := &in.FromHostInterface, &out.FromHostInterface
		*out = new(string)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new NetworkLinkEthernetMac.
func (in *NetworkLinkEthernetMac) DeepCopy() *NetworkLinkEthernetMac {
	if in == nil {
		return nil
	}
	out := new(NetworkLinkEthernetMac)
	in.DeepCopyInto(out)
	return out
}

// DeepCopyInto is an autogenerated deepcopy function, copying the receiver, writing into out. in must be non-nil.
func (in *RemediationStrategy) DeepCopyInto(out *RemediationStrategy) {
	*out = *in
	if in.Timeout != nil {
		in, out := &in.Timeout, &out.Timeout
		*out = new(metav1.Duration)
		**out = **in
	}
}

// DeepCopy is an autogenerated deepcopy function, copying the receiver, creating a new RemediationStrategy.
func (in *RemediationStrategy) DeepCopy() *RemediationStrategy {
	if in == nil {
		return nil
	}
	out := new(RemediationStrategy)
	in.DeepCopyInto(out)
	return out
}
